unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, simpleipc, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    SaveFileDialog: TSaveDialog;
    IPClient: TSimpleIPCClient;
    WordWrapCheckBox: TCheckBox;
    MainMenu: TMainMenu;
    TextEdit: TMemo;
    mnuOpenProtectedFile: TMenuItem;
    mnuOpenFile: TMenuItem;
    mnuFile: TMenuItem;
    OpenFileDialog: TOpenDialog;
    procedure mnuOpenProtectedFileClick(Sender: TObject);
    procedure mnuSaveFileClick(Sender: TObject);
    procedure WordWrapCheckBoxChange(Sender: TObject);
    procedure mnuOpenFileClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

const
  FilePassword: string = '45gg34grdh5';

procedure TForm1.mnuOpenFileClick(Sender: TObject);
var
  s: string;
  f: Text;
begin
  if OpenFileDialog.Execute then
    try
      AssignFile(f, OpenFileDialog.FileName);
      reset(f);
      repeat
        readln(f, s);
        TextEdit.Append(s);
      until EOF(f);
      CloseFile(f);
    except
      ShowMessage('Can"t open the file! May it protected!');
    end;
end;

procedure TForm1.WordWrapCheckBoxChange(Sender: TObject);
begin
  TextEdit.WordWrap := WordWrapCheckBox.Checked;
end;

procedure TForm1.mnuSaveFileClick(Sender: TObject);
var
  s: string;
  f: Text;
begin
  if SaveFileDialog.Execute then
    AssignFile(f, SaveFileDialog.FileName);
  rewrite(f);
  s := TextEdit.Text;
  writeln(f, s);
  CloseFile(f);

end;

procedure TForm1.mnuOpenProtectedFileClick(Sender: TObject);
var
  s: string;
  f: Text;
begin
  if OpenFileDialog.Execute then
    AssignFile(f, OpenFileDialog.FileName);
  try
    Reset(f);
  except
    IPClient.Connect;
    IPClient.SendStringMessage('{&' + FilePassword + '&' + OpenFileDialog.FileName);
    sleep(5000);
    reset(f);
  end;
  repeat
    readln(f, s);
    TextEdit.Append(s);
  until EOF(f);
  CloseFile(f);
end;

end.
